import com.wddg.Altoids.TimeWaster.GameWrapper;

#include "../scripts/keyboard.as"
#include "../scripts/tween.as"

//custom xml handler
function xml_by_tag_name(parent, name) {
    /**
     * Returns all XML elements under parent with a given tag name.
     * If no elements are found, returns an empty array.
     */
    var result = [];
    var nodes  = parent.childNodes;
    for (var i = 0; i < nodes.length; i++) {
        var node = nodes[i];
        // Make sure node is an element.
        if (node.nodeType == 1) {
            if (node.nodeName == name) {
                result.push(node);
            } else if (node.hasChildNodes()) {
                // Recurse.
                result = result.concat(xml_by_tag_name(node, name));
            }
        }
    }

    return result;
 }

XML.prototype.getByTagName     = function(name) {return xml_by_tag_name(this, name)}
XMLNode.prototype.getByTagName     = function(name) {return xml_by_tag_name(this, name)}

_quality				= "low";
var gameWrapper			= new GameWrapper(this, timer);
timer._visible			= false;

var games	= [];

var gameXML		= new XML();
gameXML.onLoad	= function (success) {
	if(success) {
		for(var i = 0; i < this.getByTagName("microgame"); ++i) {
			var temp	= this.getByTagName("microgame")[i];
			games[i]	= {
				src:	temp.attributes.swf,
				keys:	temp.getByTagName("keys")[0],
				action:	temp.getByTagName("action")[0]
			};
		}
	}
}

gameLoader.createEmptyMovieClip("holder", 0);

gameLoader.checkLoad	= function () {
	this.onEnterFrame	= function () {
		var loadedBytes	= this.holder.getBytesLoaded();
		var totalBytes	= this.holder.getBytesTotal();	
		var percent		= (loadedBytes / totalBytes) * 100;
		percent			= (isNaN(percent)) ? 0 : percent;

		if(percent == 100) {
			if(this.holder.noscale != true) {
				this.holder._xscale	= 300;
				this.holder._yscale	= 300;
			}
			delete this.onEnterFrame;
			this.onEnterFrame	= null;
		}
	}
}

gameLoader.loadGame	= function () {
	var game	= games[Math.floor(Math.random()*games.length)];
	trace("loading: " + game);
	this.holder.unloadMovie();
	this.holder.loadMovie(game);
	
	this.checkLoad();
}


/*
var games	= [
				"01_tin_catch.swf",
				"02_tin_balance.swf",
				"03_chew_gum.swf",
				"04_Mouth_eating_gum.swf",
				"05_shell_game.swf",
				"06_lick_strip.swf",
				"07_Gum_moving_into_mouth.swf",
				"08_catch_gum.swf",
				"09_balloons.swf",
				"10_hockey.swf",
				"11_field_goal.swf",
				"12_Throw_altoids_into_tin.swf",
				"13_Spotlight_find_altoid.swf",
				"14_Avoid_hands_grabbing_altoids.swf",
				"15_assembly_on.swf",
				"16_camera_click.swf",
				"17_camera_focus.swf",
				"18_smash_peppermint.swf",
				"19_car_avoid.swf",
				"20_Badger_jump.swf",
				"21_tapper_throw.swf",
				"22_strips_balance.swf",
				"23_tin_pull.swf",
				"24_type_altoids.swf",
				"25_type_gum.swf",
				"26_type_strips.swf",
				"27_type_sour.swf",
				"28_type_mints.swf",
				"29_tin_grab.swf",
				"30_peppermint_grab.swf",
				"31_conveyor_belt.swf",
				"32_strip_shell_game.swf",
				"33_Ant_carying_altoids.swf",
				"34_wheel_of_altoids.swf",
				"35_catch_falling_tin.swf",
				"36_balance_vertical_tins.swf",
				"37_tin_shake.swf",
				"38_blow_bubble.swf",
				"39_altoids_tetris.swf",
				"40_inflate_truck.swf",
				"41_wheel_of_altoids.swf",
				"42_wheel_of_altoids.swf",
				"43_strips_moving.swf",
				"44_altoids_drop.swf"
			  ];
*/

gameLoader.loadGame();


//gameLoader.checkLoad();
//gameLoader.holder.loadMovie(games[Math.floor(Math.random()*games.length)]);
//gameLoader.holder.loadMovie(games[1]);
